我在Docker容器中使用cgget -n --values-only --variable memory.limit_in_bytes /
来查看允许根据docker run --memory=X
使用多少内存。但是,我需要知道内存是否有限,上面的命令没有回答,因为在这种情况下它只给我一个大数(在我的测试中9223372036854771712
)
那么,有没有办法判断内存是否有限?我正在寻找不以特殊方式运行docker run
的解决方案,例如从主机安装文件(例如/var/...
)或传递环境变量。
答案 0 :(得分:6)
您可以将可用的总物理内存与cgget
给出的数字进行比较。如果cgget
给出的数字低于总物理内存,那么你肯定知道用于限制内存的cgroup。
例如,如果我在我的计算机上运行一个将内存限制为100M的容器(具有2G物理内存),cgget
将报告104857600
而free
命令报告2098950144
} bytes:
在泊坞主机上:
# free -b
total used free shared buffers cached
Mem: 2098950144 585707520 1513242624 712704 60579840 367644672
-/+ buffers/cache: 157483008 1941467136
Swap: 3137335296 0 3137335296
启动限制为100M的容器
docker run --rm -it --memory=100M <any-image-with-cgget-available> bash -l
现在在那个容器内:
# free -b
total used free shared buffers cached
Mem: 2098950144 585707520 1513242624 712704 60579840 367644672
-/+ buffers/cache: 157483008 1941467136
Swap: 3137335296 0 3137335296
# cgget -n --values-only --variable memory.limit_in_bytes /
104857600
请注意,free
命令将在docker主机上报告与容器内相同的值。
最后,以下bash脚本定义了一个函数is_memory_limited
,可用于测试以检查cgroup是否用于限制内存。
#!/bin/bash
set -eu
function is_memory_limited {
type free >/dev/null 2>&1 || { echo >&2 "The 'free' command is not installed. Aborting."; exit 1; }
type cgget >/dev/null 2>&1 || { echo >&2 "The 'cgget' command is not installed. Aborting."; exit 1; }
type awk >/dev/null 2>&1 || { echo >&2 "The 'awk' command is not installed. Aborting."; exit 1; }
local -ir PHYSICAL_MEM=$(free -m | awk 'NR==2{print$2}')
local -ir CGROUP_MEM=$(cgget -n --values-only --variable memory.limit_in_bytes / | awk '{printf "%d", $1/1024/1024 }')
if (($CGROUP_MEM <= $PHYSICAL_MEM)); then
return 0
else
return 1
fi
}
if is_memory_limited; then
echo "memory is limited by cgroup"
else
echo "memory is NOT limited by cgroup"
fi
答案 1 :(得分:0)
只需2美分,而无需安装任何第三方工具,您只需使用docker stats即可检查有限的内存
docker container run --name mytestserver -m 200M -dt nginx
在这种情况下,我将内存量限制为200M,现在进行验证
docker stats <container id>
CONTAINER ID NAME CPU % MEM USAGE / LIMIT MEM % NET I/O BLOCK I/O PIDS
3afb4a8cfeb7 mytestserver 0.00% **1.387MiB / 200MiB** 0.69% 8.48MB / 24.8kB 39.2MB / 8.25MB 2